/**********************************************************************
 * $Id: helper.h 178 2006-09-26 13:50:56Z timo $
 *
 * DMT-UX
 * DSL Modem Tool for Unix
 *
 * written by Timo Boettcher
 * inspired by A. Matthoefer
 * with help of Michael Beckers
 *
 * (C) 2006 Timo Boettcher
 * This is free software. You may redistribute copies of it under the
 * terms of the GNU General Public License (Version 2)
 * <http://www.gnu.org/licenses/gpl.html>.
 * There is NO WARRANTY, to the extent permitted by law.
 *
 *********************************************************************/

#ifndef _HELPER_H
#define _HELPER_H

#define MSGLEVEL_INFORMATION 0
#define MSGLEVEL_WARNING 1
#define MSGLEVEL_CRITICAL 2
#define MSGLEVEL_DIE 3

#include <unistd.h>
#include <sys/types.h>

int value_cap(int value, int min, int max);
void tr(char* source);
char* get_token_value(char* token, char divide);
char* get_firstvalue(char* source);
char* get_secondvalue(char* source);
void* dmalloc(unsigned int size);

void message_write(int msglevel, char* message);
void message_log_open(char* logfilename);
void message_log_close();
void pidfile_write(char* pidfilename, pid_t pid);

#endif // _HELPER_H
