/**********************************************************************
 * $Id: rrdstat.h 160 2006-09-18 16:34:29Z timo $
 *
 * DMT-UX
 * DSL Modem Tool for Unix
 *
 * written by Timo Boettcher
 * inspired by A. Matthoefer
 * with help of Michael Beckers
 *
 * (C) 2006 Timo Boettcher
 * This is free software. You may redistribute copies of it under the
 * terms of the GNU General Public License (Version 2)
 * <http://www.gnu.org/licenses/gpl.html>.
 * There is NO WARRANTY, to the extent permitted by law.
 *
 *********************************************************************/

#ifndef _RRDSTAT_H
#define _RRDSTAT_H
#ifdef rrd
void rrdstat_create_errorsecs(char* rrdfilename);
void rrdstat_create_snr(char* rrdfilename);
void rrdstat_update_errorsecs(char* rrdfilename, struct timeval tp, int value);
void rrdstat_update_snr(char* rrdfilename, struct timeval tp, int value_low, int value_LQ, int value_high);
void rrdstat_rrdgraph_errorsecs(char* rrdfilename, char* imagefilename);
void rrdstat_rrdgraph_snr(char* rrdfilename, char* imagefilename);
void rrdstat_fetch_errorsecs(char* rrdfilename, rrd_value_t** rrddata, time_t* starttime, time_t* endtime, unsigned long* steptime, unsigned long* dscount, char*** dsnames);
void rrdstat_fetch_snr(char* rrdfilename, rrd_value_t** rrddata, time_t* starttime, time_t* endtime, unsigned long* steptime, unsigned long* dscount, char*** dsnames);
#endif //rrd
#endif
