/**********************************************************************
 * $Id: types.c 177 2006-09-24 23:00:54Z timo $
 *
 * DMT-UX
 * DSL Modem Tool for Unix
 *
 * written by Timo Boettcher
 * inspired by A. Matthoefer
 * with help of Michael Beckers
 *
 * (C) 2006 Timo Boettcher
 * This is free software. You may redistribute copies of it under the
 * terms of the GNU General Public License (Version 2)
 * <http://www.gnu.org/licenses/gpl.html>.
 * There is NO WARRANTY, to the extent permitted by law.
 *
 *********************************************************************/

#include <stdlib.h>
#include <string.h>

#include "types.h"

void intarray_init(IntArray* Array) {
	Array->size=1024;
	Array->last=0;
	Array->data=malloc(sizeof(int)*Array->size);
}

void intarray_add(IntArray* Array, int Value) {
	if (Array->last==Array->size - 1) {
		char* temp = malloc(sizeof(int) * Array->size);
		memcpy(temp, Array->data, sizeof(int) * Array->size);
		Array->size+=1024;
		free(Array->data);
		Array->data=malloc(sizeof(int)*Array->size);
		memcpy(Array->data, temp, sizeof(int) * (Array->size - 1024));
		free(temp);
	}
	Array->data[Array->last]=Value;
	Array->last++;
}

void intarray_kill(IntArray* Array) {
	free(Array->data);
}



void list_init(StringList* list) {
	list->first=(StringListItem*)malloc(sizeof(StringListItem));
	list->first->command=0;
	list->first->answer=NULL;
	list->first->next=NULL;
	list->last=list->first;
}

void list_add(StringList* list, char* buf, int command) {
	char* string=(char*)malloc(sizeof(char)*strlen(buf)+1);
	strcpy(string,buf);
	list->last->answer = string;
	list->last->command = command;
	list->last->next = (StringListItem*)malloc(sizeof(StringListItem));
	list->last = list->last->next;
	list->last->answer=NULL;
	list->last->command=0;
	list->last->next=NULL;
}
void list_kill(StringList* list) {
	StringListItem* next;
	
	while (list->first) {
		next=list->first->next;
		if (list->first->answer) {
			free(list->first->answer);
		}
		free(list->first);
		list->first=next;
	}
}
