/**********************************************************************
 * $Id: types.h 177 2006-09-24 23:00:54Z timo $
 *
 * DMT-UX
 * DSL Modem Tool for Unix
 *
 * written by Timo Boettcher
 * inspired by A. Matthoefer
 * with help of Michael Beckers
 *
 * (C) 2006 Timo Boettcher
 * This is free software. You may redistribute copies of it under the
 * terms of the GNU General Public License (Version 2)
 * <http://www.gnu.org/licenses/gpl.html>.
 * There is NO WARRANTY, to the extent permitted by law.
 *
 *********************************************************************/

#ifndef _TYPES_H
#define _TYPES_H
typedef struct stringlist{
	struct stringlistitem* first;
	struct stringlistitem* last;
} StringList;

typedef struct stringlistitem{
	int command;
	char* answer;
	struct stringlistitem* next;
} StringListItem;

typedef struct array_t{
	int size;
	int last;
	char* data;
} IntArray;



typedef struct modem_t{
	char* modemvendor;
	char* modemname;
	char* modemnumber;
	char* modemboardname;
	char* modembootloader;
	char* modemfirmware;
	char* modemserial;
	char* modemmacaddr;
	char* modemoperationmode;
	char* modemchannelmode;
	char* modemstate;
	char* linelength;

	char* downstream;
	char* downstream_cells;
	char* downstream_bytes;
	char* upstream;
	char* upstream_cells;
	char* upstream_bytes;
	char* modemattenuation;
	char* modemattenuation_up;
	char* modemattenuation_down;
	char* modemmargin;
	char* modemmargin_up;
	char* modemmargin_down;
	char* modemoutputpower;
	char* modemoutputpower_up;
	char* modemoutputpower_down;
	char* revision;
	char* revision_local;
	char* revision_remote;
	char* vendor;
	char* vendor_local;
	char* vendor_remote;
	char* vendorspecific;
	char* vendorspecific_local;
	char* vendorspecific_remote;

	int noise_low;
	int noise_high;
	int noise_LQ;
} Modem;



void intarray_init(IntArray* Array);
void intarray_add(IntArray* Array, int Value);
void intarray_kill(IntArray* Array);


void list_init(StringList* list);
void list_add(StringList* last, char* buf, int command);
void list_kill(StringList* list);
#endif //_TYPES_H
